/* Programmation des décodeurs sur le circuit imprimé du V&V
 * msport 10/6/2022
 * Utilisation de la bibliothèque DCCpp sur la voie MAIN
 * le V&V doit être alimenté en 12/15V pour que SEL fonctionne, du à un partage de l'entrée A2 avec la mesure de tension
 * © Locoduino
*/

#include "DCCpp.h"

char * VERS = "Decodeur.1";
char* titre[]={"           ", "CV : ", "CV choisi  ", "ECRITURE ?", "Loco#= ","ECRITURE ! ",
"Adresse : ", "#CV choisi ", "CV", "CV non lu ", "CV# : ", "choix CV   ", "choix #CV  ",}; //   de 0 à 5 et 6 à 12 

#include <Encoder.h> //https://downloads.arduino.cc/libraries/github.com/PaulStoffregen/Encoder-1.4.2.zip
Encoder myEnc(2, 4);
long oldPosition  = -999;
long newPosition;
int noCV = 1; 
int valeurCV = 0; // du CV
int valeur = 1; // du codeur
int adLoco; 
bool okCV = false;
bool okValeurCV = false;
bool choixValeurCV = false;
bool choixCV = true;
bool okEcriture = false;

// Include the Bounce2 library found here : https://github.com/thomasfredericks/Bounce2
#include <Bounce2.h>
Bounce debouncer1 = Bounce(); // Instantiate  Bounce objects
Bounce debouncer2 = Bounce();
Bounce debouncer3 = Bounce();
Bounce debouncer4 = Bounce();
#include <Wire.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#define I2C_ADDRESS 0x3C // 0X3C+SA0 - 0x3C or 0x3D
SSD1306AsciiWire oled;
#define MOTOR_SHIELD_TYPE   0     //  L298
#define COMM_INTERFACE   0        //  serial    
#define debug  0        //  debugging si 1    

void afficheOled() {
  oled.setCursor(0, 2);   //   2e ligne
  oled.print(titre[1]);   //   2e ligne CV : 
  oled.print(noCV);      
  oled.print(titre[0]);   // espaces  
  oled.setCursor(0, 4);   // 3e ligne  0 2 4 6
  oled.print(titre[10]);  // CV#  3e ligne  
  oled.print(valeurCV);
  oled.print(titre[0]);   // espaces  
}
  
void setup() {
  // put your setup code here, to run once:
  Serial.begin( 115200 );
  DCCpp::begin(); //
  DCCpp::beginMain(UNDEFINED_PIN, 10, 3, 14); // pour v&v Prog
  DCCpp::powerOn();
  Serial.println( "Decodeur.1" );
  if (debug) { for (int i = 0; i < 13; i++) { Serial.println(titre[i]);}  }
  debouncer1.attach(17, INPUT_PULLUP ); // UP rouge A3 pour pcb C6 (D12 pour pcb C41)
  debouncer1.interval(5); // interval in ms
  debouncer2.attach(13, INPUT_PULLUP ); // DOWN noir
  debouncer2.interval(5); // interval in ms
  debouncer3.attach(16, INPUT_PULLUP ); // SEL A2 vert
  debouncer3.interval(5); // interval in ms
  debouncer4.attach(15, INPUT_PULLUP ); // coder button A1
  debouncer4.interval(5); // interval in ms
  Wire.begin();         
  oled.begin(&Adafruit128x64, I2C_ADDRESS);
  oled.set400kHz();
  oled.setFont(System5x7);  
  oled.set2X();
  oled.clear();
  oled.setCursor(0, 0); // start of 1st line
  oled.println(VERS);   
  oled.setCursor(0, 4); // start of  3th
  oled.println("(c)");  
  oled.print("Locoduino");  
  adLoco = DCCpp::identifyLocoIdMain();
  delay(2000);
  oled.setCursor(0, 4); // start of  3th
  oled.println(titre[0]);   // espaces  
  oled.print(titre[0]);   // espaces  
  delay(2000);
  if (debug) {Serial.print("Loco # = ");  Serial.print(adLoco);}
  oled.setCursor(0, 2); // 2e ligne
  if ( adLoco == -1 )  { oled.print(titre[9]);} else {oled.print(titre[6]);}     // Adresse lue / CV# lu
  oled.setCursor(0, 4); // 3e ligne
  oled.print(adLoco); 
  myEnc.write(4);  
  valeurCV = adLoco ; 
  delay(2000);

}  // END SETUP

void loop() {
  debouncer4.update();  // coder button A1 writeCV
  int value4 = debouncer4.read();
  if ( debouncer4.fell() ) { 
   if ( okCV && okValeurCV ) { 
    oled.setCursor(0, 0);          //      1ere ligne  
    oled.print(titre[5]);          //      ECRITURE !    
    if (debug) {Serial.print("Loco # = ");  Serial.println(adLoco);
      Serial.print("ECRITURE valeur CV = ");  Serial.print(valeurCV);}
    oled.setCursor(0, 2);          //      2e ligne
    oled.print(titre[4]); oled.print(adLoco);  // Loco#= 
    oled.setCursor(0, 4);          //      3e ligne
    oled.print(titre[0]);          //      espaces  
    oled.setCursor(0, 4);          //      3e ligne
    oled.print(titre[8]);oled.print(noCV);   oled.print(" = ");   // "CV"   
    oled.print(valeurCV); 
    oled.setCursor(0, 6);          //      4e ligne
    oled.print("             ");    
    // static bool   writeCvMain (int inCvId, byte inValue, int callBack=100, int callBackSub=200)
    DCCpp::writeCvMain (noCV, valeurCV, 100, 200);
    oled.setCursor(0, 6);          //  4e ligne
    oled.print("CV"); oled.print(noCV); oled.print(" = "); oled.print(DCCpp::readCvMain (noCV, 100, 200));
    if (debug) { Serial.print("writeCvMain "); Serial.print(noCV); Serial.print(", "); Serial.print(valeurCV); Serial.println(", 100, 200 ");}
    delay(100);
    okEcriture = false;    // RAZ
    okCV = false;
    choixValeurCV = false; 
   }
   else {
    oled.setCursor(0, 6);          //  4e ligne  
    oled.print(titre[12]);         // choix #CV     
   }
  }  

  debouncer2.update(); // DOWN noir : affichage du CV en cours et choix d'une nouvelle valeur à valider par SEL
  int value2 = debouncer2.read();
  if ( debouncer2.fell() ) { 
    oled.setCursor(0, 0);          // 1e ligne  
    oled.print(titre[11]);         // choix CV    
    afficheOled();
    myEnc.write(4*noCV); newPosition = 4*noCV ; oldPosition = 4*noCV ;
    noCV = myEnc.read()/4 ;
    choixCV = true;  choixValeurCV = false; 
    oled.setCursor(0, 6);          // 4e ligne  
    oled.print(titre[0]);          // espaces    
    
  }   // END DOWN noir 

  debouncer3.update(); // SEL vert 
  int value3 = debouncer3.read();
  if ( debouncer3.fell() ) { 
    afficheOled();
    if (! choixCV && choixValeurCV && okCV  ){
      okValeurCV  = true; 
      oled.setCursor(0, 6);                       // 4e ligne  0 2 4 6
      oled.print(titre[3]);                       //   ECRITURE ?
    }
    if (choixCV){
      choixCV = false;
      okCV  = true; 
      choixValeurCV = true;
      valeurCV = DCCpp::readCvMain (noCV, 100, 200);
      oled.print(titre[2]);                       // CV choisi
      oled.setCursor(0, 4);                       // 3e ligne  0 2 4 6
      oled.print(titre[10]);                      // CV#
      oled.print(valeurCV);       
      oled.print(titre[0]);                       // espaces
      oled.setCursor(0, 6);                       // 3e ligne  0 2 4 6
      oled.print(titre[0]);                       // espaces
      myEnc.write(4*valeurCV); newPosition = 4*valeurCV ; oldPosition = 4*valeurCV ;
    }
    oled.setCursor(0, 0);                         // 1e ligne  
    if (okValeurCV) { oled.print(titre[7]); }     // CV# choisi  
  }   // END SEL vert
/*
  debouncer1.update(); // UP rouge selection de la valeur du CV
  int value1 = debouncer1.read();
  if ( debouncer1.fell() ) { 
   // Utilisation ultérieure
}  // END UP rouge
*/
  newPosition = myEnc.read();
  if (newPosition != oldPosition) {
    oldPosition = newPosition;
    valeur = constrain(newPosition/4, 0, 255) ;
    oled.setCursor(0, 6);                         // 4e ligne  0 2 4 6
    if (debug) {
      oled.print(" >");  // pour debugger
      oled.print(valeur);    
      oled.print(titre[0]);
    }
   
    if (choixCV == true){  
      noCV = valeur ; 
    } 
    if (choixValeurCV == true){ 
      valeurCV = valeur ; 
    }  
    afficheOled();
    if (debug) { Serial.println(valeur);}
  } 

}  // END LOOP
